<?php
/**
 * @file
 * Contains Licensing information for miniOrange SAML Login Module.
 */

 /**
 * Showing Licensing form info.
 */
namespace Drupal\miniorange_saml\Form;

use Drupal\Core\Form\FormBase;

class MiniorangeLicensing extends FormBase {
	
public function getFormId() {
    return 'miniorange_saml_licensing';
  }
 
public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {

    $form['markup_1'] = array(
      '#markup' => '<table class="mo_saml_local_pricing_table">'
      . '<h2>Licensing Plans</h2><hr>'
      . '<tr style="vertical-align:top;">',
    );

    $form['markup_free'] = array(
        '#attached' => array(
            'library' => 'miniorange_saml/miniorange_saml.license',
        ),
        '#markup' => '<td><div class="mo_saml_local_thumbnail mo_saml_local_pricing_free_tab" align="center" >'
            . '<h3 class="mo_saml_local_pricing_header">Free</h3><p></p>'
            . '<h4 class="mo_saml_local_pricing_sub_header" style="padding-bottom:8px !important;">'
            . '---Your are on this plan---</h4><hr>'
            . '<p class="mo_saml_local_pricing_text" style="padding:10px;">$0 - Free Plan For Trial</p><br><hr>'
            . '<p class="mo_saml_local_pricing_text">'
            . 'Unlimited Authentications via IdP<br>Basic Role Mapping<br>Basic Attribute Mapping<br>'
            . 'Matadata XML File<br>Step-By-Step Guide to Setup IdP<br>'
            . '<br/><br/><br/><br/><br/><br/></p><hr>'
            . '<p class="mo_saml_local_pricing_text" >Basic Support by Email</p></div></td>',
    );

    $form['markup_Do_it_yourself'] = array(
	'#attached' => array(
	'library' => 'miniorange_saml/miniorange_saml.license',
	),
      '#markup' => '<td><div class="mo_saml_local_thumbnail mo_saml_local_pricing_paid_tab" align="center" >'
      . '<h3 class="mo_saml_local_pricing_header">Do it yourself</h3><p></p>'
      . '<h4 class="mo_saml_local_pricing_sub_header" style="padding-bottom:8px !important;">'
      . '<a target="_blank" id="doItYourselfButton" class="btn btn-primary btn-sm" style="padding:5px;">Click to Upgrade</a>*</h4><hr>'
      . '<p class="mo_saml_local_pricing_text" style="padding:10px;">$349 - One Time Payment</p><br><hr>'
      . '<p class="mo_saml_local_pricing_text">'
      . 'Unlimited Authentications via IdP<br>Customized Role Mapping<br>Customized Attribute Mapping<br>'
      . 'Auto-Redirect to IdP<br>Step-By-Step Guide to Setup IdP<br>Single Logout<br>Protect your whole site<br>'
      . 'Options to select SAML Request Binding Type<br>Integrated Windows Authentication *<br><br><br/></p><hr>'
      . '<p class="mo_saml_local_pricing_text" >Basic Support by Email</p></div></td>',
    );
  

  $form['markup_premium'] = array(
  '#attached' => array(
	'library' => 'miniorange_saml/miniorange_saml.license',
	),
    '#markup' => '<td><div class="mo_saml_local_thumbnail mo_saml_local_pricing_paid_tab" align="center">'
    . '<h3 class="mo_saml_local_pricing_header">Premium</h3><p></p>'
    . '<h4 class="mo_saml_local_pricing_sub_header" style="padding-bottom:8px !important;">'
    . '<a target="_blank" id="premiumButton" class="btn btn-primary btn-sm" style="padding:5px;">Click to upgrade</a>*</h4><hr>'
    . '<p class="mo_saml_local_pricing_text">$349 + One Time Setup Fees <br>( $60 per hour )</p><hr>'
    . '<p class="mo_saml_local_pricing_text">Unlimited Authentications via IdP<br>Customized Role Mapping<br>'
    . 'Customized Attribute Mapping<br>Auto-Redirect to IdP<br>Step-By-Step Guide to Setup IdP<br>Single Logout<br>Protect your whole site<br>'
    . 'Options to select SAML Request Binding Type<br>Integrated Windows Authentication *<br>Multiple IdP Support for Cloud Service Providers<br>'
    . 'End to End Identity Provider Configuration **<br></p><hr><p class="mo_saml_local_pricing_text">Premium Support Plans Available</p>'
    . '</div></td></tr></table>'
  );

  
  $form['markup_4'] = array(
    '#markup' => '<h3>Identity Providers Supported</h3>'
    . 'Google Apps, ADFS, Okta, Salesforce, Shibboleth, SimpleSAMLphp, OpenAM, Centrify, Ping, RSA'
    . ', IBM, Oracle, OneLogin, Bitium, WSO2, NetIQ, miniOrange Identity Provider'
  );

  $form['markup_5'] = array(
    '#markup' => '<h3>Steps to Upgrade to Premium Plugin</h3>'
    . '<ol><li>You will be redirected to miniOrange Login Console. Enter your password with which you created an'
    . ' account with us. After that you will be redirected to payment page.</li>'
    . '<li>Enter you card details and complete the payment. On successful payment completion, you will see the link to download the premium plugin.</li>'
    . 'Once you download the premium plugin, just unzip it and replace the folder with existing plugin. Clear Drupal Cache.</li></ol>'
  );
  $form['markup_7'] = array(
    '#markup' => '<h3>*Integrated Windows Authentication (Supported with ADFS)</h3>'
        . 'With Integrated windows authentication, if the user comes to your Drupal Site from a domain joined machine'
        . ' then he will not even have to re-enter his credentials,<br> because he already did that when he unlocked his computer.
            <br></div>'
  );

  $form['markup_6'] = array(
    '#markup' => '<h3>** End to End Identity Provider Integration (Additional charges may apply)</h3>'
    . 'We will setup a Conference Call / Gotomeeting and do end to end configuration for you for IDP '
    . 'as well as plugin. We provide services to do the configuration on your behalf.<br><br>
    If you have any doubts regarding the licensing plans, you can mail us at<a href="mailto:info@miniorange.com"><i>info@miniorange.com</i></a> or submit a query using the support form <b>(support form available on each tab)</b>.'
  );

  return $form;
 }
 
  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
  }
 }